
/*============================================================================
 Name        : main.c
 Author      : atao
 Version     : Demo V2.0.A.2
 Copyright   : ZKTeco.
 Description : main in Linux C
 ============================================================================*/

#include "libtype.h"
#include "libuserCmd.h"
#include "main.h"

FILE *logFile = NULL;

WINDOW *win, *win1, *win2;
INT Dev_num = 1;	//dev:usb or ff232

#define	USER_DIR		"./User"
#define TEMPLATE_DIR	"./Templates"
#define	LOGS_DIR		"./Logs"
#define DEBUG_FILE		"debug.log"
#define FIRMWARE_SIZE 	(1024*1024)
#define DIRSIZE			256
#define DEV_USB			0
#define DEV_232			1


#ifndef 	DEBUG
#define 	DEBUG				1	//debug info output to file
#endif
const INT parameter_value[] =
{
		SID_SAVE_LOG,
		SID_AUTO_ACK,
		SID_TIMEOUT,
		SID_FW_VER,
		SID_BAUDRATE,
		SID_ENROLL_FP,
		SID_FP_COUNT,
		SID_USER_COUNT,
		SID_LOG_NUM,
		SID_LOG_COUNT,
		SID_BUILD_NUM,
		SID_MODULE_ID,
		SID_FP_FORMAT,
		SID_MODULE_IDENTIFY
};
INT DebugFilInit(VOID)
 {
	while(1)
	{
		if(NULL == (logFile = fopen(DEBUG_FILE, "a+")))
		{
			//return FAILURE;
			continue;
		}
		else
		{
			break;
		}
	}
	return SUCCESS;
 }

/**************************** save image ******************************/
int WriteBitmap(U8 *buffer, S32 Width, S32 Height, CHAR * FileName)
{
	int i = 0,w = 0;
	FILE *f = NULL;
	CHAR Buffer[0x500];
	BITMAPFILEHEADER * bmpfheader;
	BITMAPINFO *bmpinfo;
	bmpfheader = (BITMAPFILEHEADER * )Buffer;
	bmpinfo = (BITMAPINFO *)(((char*)bmpfheader)+14);


	memset(bmpfheader,0,0x500);
	bmpfheader->bfType =19778;
	bmpfheader->bfSize = ((Width+3)/4)*4*Height+sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFO)+255*sizeof(RGBQUAD);
	bmpfheader->bfOffBits = sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFO)+255*sizeof(RGBQUAD);
	bmpinfo->bmiHeader.biWidth=Width;
	bmpinfo->bmiHeader.biHeight=Height;
	bmpinfo->bmiHeader.biBitCount=8;
	bmpinfo->bmiHeader.biClrUsed=0;
	bmpinfo->bmiHeader.biSize=sizeof(bmpinfo->bmiHeader);
	bmpinfo->bmiHeader.biPlanes=1;
	bmpinfo->bmiHeader.biSizeImage=((Width+3)/4)*4*Height;
	f=fopen(FileName, "wb");
	if(f)
	{
		for(i=1;i<256;i++)
		{
			bmpinfo->bmiColors[i].rgbBlue=i;
			bmpinfo->bmiColors[i].rgbGreen=i;
			bmpinfo->bmiColors[i].rgbRed=i;
		}
		fwrite(Buffer, sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+256*sizeof(RGBQUAD), 1, f);
		w = ((Width+3)/4)*4;
		for(i=0; i<Height; i++)
		{
			fwrite(buffer, Width, 1, f);
			if(w-Width)
				fwrite(buffer, w-Width, 1, f);
			buffer+=Width;
		}
		fclose(f);
		return Width*Height;
	}
	return 0;
}

VOID save_bmp(U8 *buffer, S32 Width, S32 Height)
{
	static int times = 1;
	CHAR name[128] = {0};

	sprintf(name, "bmp_%02d.bmp", times++);
	WriteBitmap(buffer, Width, Height, name);
	times = ((times >=8) ? 1: times);
}

/**************************** windown fun ******************************/
INT CursesInit(VOID)
{
	//win init
	initscr();
	clear();

	//main window
	win = newwin(WIN_LINE, WIN_COL, 0, 0);
	//debug window
	win1 = newwin(6, WIN_COL - 2, WIN_LINE - 6, 1);
	//info window
	win2 = newwin(WIN_LINE - 7, WIN_COL - 2, 1, 1);
	return SUCCESS;
}

VOID WinBox(VOID)
{
	box(win, ACS_VLINE, ACS_HLINE);
	mvwprintw(win, 0, 2, "Slk20 Demo_%s", DEMOVERSION);
	box(win1, ACS_VLINE, ACS_HLINE);
	mvwprintw(win1,0, 2, "Dubeg");
	box(win2, ACS_VLINE, ACS_HLINE);
	mvwprintw(win2, 0, 2, "Print info");
}

VOID CloseWin(VOID)
{
	//close window
	refresh();
	wrefresh(win);
	wrefresh(win1);
	sleep(0);
	delwin(win);
	delwin(win1);
	delwin(win2);
    endwin();
}

VOID DebugWin(WINDOW *win1, int num)
{
	WinBox();
	wrefresh(win1);
	sleep(num);
	wclear(win1);
}

int main(int argv, char *argc[])
{
	int count = 0;
	int exit_flag = 0;
	int reset_flag = -1;
	int ret = 0;
	int flag = 0;
	int value = 0;
	int i = 0;
	int index = 1;
	int Year = 0;
	int Month = 0;
	int Day = 0;
	int Hour = 0;
	int Minute = 0;
	int Second = 0;
	int num = 0;
	signed long width = 0;
	signed long height = 0;
	int userID = 0;
	char event = 0;
	char verified = 0;
	int reserved = 0;
	char name[8];
	char password[5];
	char filename[DIRSIZE];
	static char Device[15] = {"\0"};
	char devName[7] = {"\0"};
	U8 privilege = '\0';
	U8 fingerprintNum = '\0';
	U8 Card[5];
	U8 *data = NULL;
	U8 lamp_time = 0;
	U8 lamp_type = 0;
	U16 secLevel = 0;
	U32 PIN2 = 0;
	U32 date = 0;
	U32 time = 0;
	U32 fsize = 0;
	//create thread
    pthread_t id;
    VOID *thread_result;
    INT arg = 0;
    //test time
	U32 startTime = 0;
	U32 curTime = 0;

	while(1)
	{
		/****************** INIT *******************/
		CursesInit();

		WinBox();
		//dev select.  usb or 232 ?
		mvwprintw(win, 7, 24, "Welcome to use ZK_Silk20 Demo!");
		mvwprintw(win, 10, 20, "Please select dev[0-usb or 1-ff232]:");
		mvwscanw(win, 10, 56, "%d", &Dev_num);
		fflush(stdin);

		if(Dev_num == DEV_232)
		{
			mvwprintw(win, 10, 41, "                      ");
			memset(Device, 0, sizeof(Device));
			memset(devName, 0, sizeof(devName));
			mvwprintw(win, 10, 20, "Please input devName--[ttyS0]:");
			mvwscanw(win, 10, 50, "%s", devName);
			fflush(stdin);
			devName[6] = '\0';
			sprintf(Device, "/dev/%s", devName);
		}
		wclear(win);
		//usb & 232
		ret = Connect(Device, Dev_num);

		if(ret == SUCCESS)
		{
			mvwprintw(win1, 2, 1, "Connect OK!");
		}
		else if(ret == FAILURE)
		{
			mvwprintw(win1, 2, 1, "Connect err!");
		}

		/***************** Exe UserCmd ******************/

		while(1)
		{
			DebugFilInit();
			exit_flag = 0;
			WinBox();
			PrintInfo();
			mvwprintw(win, WIN_LINE - 7, 2, "Please select:");
			wclrtoeol(win);
			wclear(win1);

			//free scan user
			userID = FreeScan();
			GetFreeScan(userID);

			if(!AUTODEBUG)
			{
				if(mvwscanw(win, WIN_LINE - 7, 16, "%d", &num) != 1)
				{
					WinBox();
					mvwprintw(win1, 1, 1, "Input num err...");
					CloseWin();
					return FALSE;
				}
				fflush(stdin);
			}
			else if(ret)
			{
				startTime = GetTicks();
			    if(pthread_create(&id, NULL, threadAutoDebug, (VOID *)&arg))
			    {
			    	curTime = GetTicks();
			    	ret = 1;
			    }
			    else
			    {
			    	ret = 0;
			    }
				pthread_join(id, &thread_result);
				mvwprintw(win1, 1, 1, "[ Debug ]Thread joined,it returned:%s count = %d",(char *)thread_result, arg);
				DebugWin(win1, 3);
				num = 11;
			}
			wrefresh(win);
			if(Dev_num == DEV_USB)
			{
				Clear();
			}
			count = 0;
			switch(num)
			{
				case 1:
					input_info(&userID);
					mvwprintw(win1, 1, 1, "Please press figerprint!(3 times) >>>");
					DebugWin(win1, 0);
					startTime = GetTicks();
					ret = EnrollUserByScan(userID);
					curTime = GetTicks();
					break;
				case 2:
					input_info(&userID);
					mvwprintw(win, WIN_LINE - 7, 2, "Please input filename:");
					wclrtoeol(win);
					memset(filename, 0, sizeof(filename));
					mvwscanw(win, WIN_LINE - 7, 24, "%s", filename);
					fflush(stdin);
					mvwprintw(win1, 1, 1, "Please wait a moment, data is receving ...");
					DebugWin(win1, 1);
					data = malloc(IMAGE_SIZE);
					if(data == NULL)
					{
						mvwprintw(win1, 1, 1, "[ err ]malloc err ...");
						DebugWin(win1, 1);
						break;
					}
					//read local finger image  y/n?
					if(readFingerImage(data, &width, &height, filename))
					{
						mvwprintw(win1, 1, 1, "Please wait a moment, data is sending ...");
						DebugWin(win1, 2);
						startTime = GetTicks();
						ret = EnrollTemplateByImage(userID, data, width * height);
						curTime = GetTicks();
					}
					if(data != NULL)
					{
						free(data);
						data = NULL;
					}
					break;
				case 3:
					mvwprintw(win1, 1, 1, "Please press figerprint! >>>");
					DebugWin(win1, 10);
					if(Dev_num == DEV_USB)
					{
						Clear();
					}
					mvwprintw(win1, 1, 1, "Please wait a moment, data is receving ...");
					DebugWin(win1, 1);
					data = malloc(IMAGE_SIZE);
					if(data == NULL)
					{
						mvwprintw(win1, 1, 1, "[ err ]malloc err ...");
						DebugWin(win1, 1);
						break;
					}
					startTime = GetTicks();
					if((ret = GetFingerImage((int *)&width, (int *)&height, data)))
					{
						curTime = GetTicks();
						save_bmp(data, width, height);
					}
					if(data != NULL)
					{
						free(data);
						data = NULL;
					}
					break;
				case 4:
					data = malloc(IMAGE_SIZE);
					if(data == NULL)
					{
						mvwprintw(win1, 1, 1, "[ err ]malloc err ...");
						DebugWin(win1, 1);
						break;
					}
					mvwprintw(win, WIN_LINE - 7, 2, "Please input filename:");
					wclrtoeol(win);
					memset(filename, 0, sizeof(filename));
					mvwscanw(win, WIN_LINE - 7, 24, "%s", filename);
					fflush(stdin);
					mvwprintw(win1, 1, 1, "Please wait a moment, data is receving ...");
					DebugWin(win1, 0);
					if(readFingerImage(data, &width, &height, filename))
					{
						mvwprintw(win1, 1, 1, "Please wait a moment, data is sending ...");
						DebugWin(win1, 0);
						startTime = GetTicks();
						if((ret = IdentifyByImage(width * height, &userID, &index, data)))
						{
							curTime = GetTicks();
							mvwprintw(win1, 2, 1, "userID: %d\tindex: %d", userID, index);
							fprintf(logFile, "userID: %d\tindex: %d\r\n", userID, index);
						}
						else
						{
							mvwprintw(win1, 2, 1, "User not exist!");
						}
					}
					if(data != NULL)
					{
						free(data);
						data = NULL;
					}
					break;
				case 5:
					input_info(&userID);
					mvwprintw(win1, 1, 1, "Please press finger >>> ");
					DebugWin(win1, 0);
					startTime = GetTicks();
					ret = Verify(userID);
					curTime = GetTicks();
					break;
				case 6:
					startTime = GetTicks();
					ret = DeleteAllLogs();
					curTime = GetTicks();
					break;
				case 7:
					mvwprintw(win1, 1, 1, "[Debug]:Clearing database  ...");
					DebugWin(win1, 1);
					startTime = GetTicks();
					ret = ClearDB();
					curTime = GetTicks();
					break;
				case 8:
					touchwin(win2);
					i = 0;
					mvwprintw(win2, 1, 1, "USERID EVENT VERIFIED DATE\t  TIME     RESERVED");
					while(1)
					{
						if(i == 14)
						{
							mvwprintw(win2, 2 + i, WIN_COL - 15, "[More]...>>>");
							i = 0;
						}
						startTime = GetTicks();
						if(ReadAllLogs(&userID,  &event, &verified,	&date, &time, (char *)&reserved))
						{
							curTime = GetTicks();
							TimeAnalyse(date, time, &Year, &Month, &Day,  &Hour, &Minute, &Second);
							mvwprintw(win2, 2 + i, 1, "%-7d%-6d%-9d%-4d/%-2d/%-2d %-2d:%-2d:%-3d%",
									userID, event, verified,
									Year + 2000, Month, Day, Hour, Minute, Second);
							i++;
						}
						else
						{
							break;
						}
					}
					wrefresh(win2);
					wclear(win2);
					WL_FILE();//write logs file
					break;
				case 9:
					mvwprintw(win, WIN_LINE - 7, 2, "Please input DATA[Y/M/D h:m:s]:");
					wclrtoeol(win);
					mvwscanw(win, WIN_LINE - 7, 33, "%d/%d/%d %d:%d:%d", &Year, &Month, &Day, &Hour, &Minute, &Second);
					fflush(stdin);
					startTime = GetTicks();
					ret = SetTime(Year, Month, Day, Hour, Minute, Second);
					curTime = GetTicks();
					break;
				case 10:
					startTime = GetTicks();
					ret = GetTime(&Year, &Month, &Day,  &Hour, &Minute, &Second);
					curTime = GetTicks();
					mvwprintw(win2, 5, 25, "SlikID Data: %d/%d/%d %d:%d:%d",
								Year + 2000, Month, Day, Hour, Minute, Second);
					touchwin(win2);
					wrefresh(win2);
					wclear(win2);
					break;
				case 11:
					ret = GetStatus();
					if(ret)
					{
						mvwprintw(win1, 2, 1, "SystemStatus: Busy!");
					}
					break;
				case 12:
					ret = ReadParameter();
					break;
				case 13:
					while(1)
					{
						mvwprintw(win1, 1, 1, "[Info]:flag{0x31,0x36,0x50,0x62,0x6D,0x82}");
						DebugWin(win1, 3);
						mvwprintw(win, WIN_LINE - 7, 2, "Please input flag[0x??]:");
						wclrtoeol(win);
						mvwscanw(win, WIN_LINE - 7, 26, "%p", &flag);
						fflush(stdin);
						if((flag == SID_MODULE_ID) || (flag == SID_SAVE_LOG) ||	(flag == SID_AUTO_ACK) ||
								(flag == SID_TIMEOUT) || (flag == SID_MODULE_IDENTIFY) || (flag == SID_GPIO_LEVEL))
						{
							break;
						}
						else
						{
							mvwprintw(win1, 1, 1, "[Debug]:Parameter not to write");
							DebugWin(win1, 1);
						}
					}
					if(flag == SID_GPIO_LEVEL)
					{
						mvwprintw(win1, 1, 1, "[Info]:lamp_time{0x31->1s ... 0x3a->10s ... 0x44->20s}");
						DebugWin(win1, 3);
						mvwprintw(win, WIN_LINE - 7, 2, "Please input lamp timeout[0x??]:");
						wclrtoeol(win);
						mvwscanw(win, WIN_LINE - 7, 34, "%p", &lamp_time);
						fflush(stdin);
						mvwprintw(win1, 1, 1, "[Info]:lamp_type{0x80->Green,0x40->Red,0xC0->Yellow}");
						DebugWin(win1, 3);
						mvwprintw(win, WIN_LINE - 7, 2, "Please input lamp type[0x??]:");
						wclrtoeol(win);
						mvwscanw(win, WIN_LINE - 7, 31, "%p", &lamp_type);
						fflush(stdin);
						value = lamp_type & 0xffff;
						value <<= 8;
						value = lamp_time & 0xffff;
					}
					else
					{
						mvwprintw(win, WIN_LINE - 7, 2, "Please input Parameter values[0x??]:");
						wclrtoeol(win);
						mvwscanw(win, WIN_LINE - 7, 38, "%p", &value);
						fflush(stdin);
					}
					startTime = GetTicks();
					ret = SetParameter(value, flag);
					curTime = GetTicks();
					break;
				case 14:
					startTime = GetTicks();
					ret = SaveParameter();
					curTime = GetTicks();
					break;
				case 15:
					startTime = GetTicks();
					ret = DeleteAllUsers();
					curTime = GetTicks();
					break;
				case 16:
					input_info(&userID);
					startTime = GetTicks();
					ret = DeleteUser(userID);
					curTime = GetTicks();
					break;
				case 17:
					mvwprintw(win1, 1, 1, "[Debug]:Is reading user...");
					DebugWin(win1, 1);
					i = 1;
					mvwprintw(win2, 1, 1, "USERID NAME  PASSWORD SECLEVEL PRIVILEGE FIGERPRINTNUM  PIN2\t\tCARD");
					startTime = GetTicks();
					while(1)
					{
						if(14 == i)
						{
							mvwprintw(win2, 2 + i, WIN_COL - 15, "[More]...>>>");
							i = 0;
						}
						if(ReadAllUser(&userID, name, password, &secLevel, &PIN2, &privilege, &fingerprintNum, Card))
						{
							mvwprintw(win2, 2 + i, 1, "%-7d%-6s%-9s%-9d%-10x%-15hhu%-14ld%5s", userID,
								name, password, secLevel, privilege, fingerprintNum, PIN2, Card);
							i++;
							count++;
						}
						else
						{
							ret = 1;
							break;
						}
					}
					curTime = GetTicks();
					mvwprintw(win1, 2, 1, "User count = %d", count);
					DebugWin(win1, 3);
					touchwin(win2);
					wrefresh(win2);
					werase(win2);
					WU_FILE();//wirte user file
					break;
				case 18:
					input_info(&userID);
					startTime = GetTicks();
					if((ret = GetUser(userID, name, password, &secLevel, &PIN2, &privilege, &fingerprintNum, Card)))
					{
						curTime = GetTicks();
						mvwprintw(win2, 1, 1, "userID name  password secLevel privilege figerprintNum  PIN2\t\tCard");
						mvwprintw(win2, 2, 1, "%-7d%-6s%-12s%-9d%x\t\t%hhu\t %ld\t\t%5s",userID,
								name, password, secLevel, privilege, fingerprintNum, PIN2, Card);
					}
					touchwin(win2);
					wrefresh(win2);
					wclear(win2);
					break;
				case 19:
					memset(Card, 0, sizeof(Card));
					new_user(&userID, name, password, Card);
					startTime = GetTicks();
					ret = ModifyUser(userID, name, password, 0, userID, 0, 0, Card);
					curTime = GetTicks();
					break;
				case 20:
					input_info(&userID);
					mvwprintw(win, WIN_LINE - 7, 2, "Please input flag[0 or 1]:");
					wclrtoeol(win);
					mvwscanw(win, WIN_LINE - 7, 28, "%d", &flag);
					fflush(stdin);
					mvwprintw(win, WIN_LINE - 7, 2, "Please input filename:");
					wclrtoeol(win);
					memset(filename, 0, sizeof(filename));
					mvwscanw(win, WIN_LINE - 7, 24, "%s", filename);
					fflush(stdin);
					data = malloc(TEMPLATES_SIZE);
					if(data == NULL)
					{
						mvwprintw(win1, 1, 1, "[ err ]malloc err ...");
						DebugWin(win1, 1);
						break;
					}
					if((ret = ReadTempFromPc(data, filename)))
					{
						startTime = GetTicks();
						ret = SetTemplates(userID, flag, data, TEMPLATES_SIZE);
						curTime = GetTicks();
					}
					if(data != NULL)
					{
						free(data);
						data = NULL;
					}
					break;
				case 21:
					input_info(&userID);
					mvwprintw(win, WIN_LINE - 7, 2, "Please input index(0~9):");
					wclrtoeol(win);
					mvwscanw(win, WIN_LINE - 7, 26, "%d", &index);
					fflush(stdin);
					mvwprintw(win, WIN_LINE - 7, 2, "Please input flag[0 or 1]:");
					wclrtoeol(win);
					mvwscanw(win, WIN_LINE - 7, 28, "%d", &flag);
					fflush(stdin);
					startTime = GetTicks();
					ret = DeleteTemplates(userID, index, flag);
					curTime = GetTicks();
					break;
				case 22:
					startTime = GetTicks();
					ret = DeleteAllTemplates();
					curTime = GetTicks();
					break;
				case 23:
					startTime = GetTicks();
					ReadTempFromM(0);//write templates file
					curTime = GetTicks();
					break;
				case 24:
					startTime = GetTicks();
					ReadTempFromM(1);//write templates file
					curTime = GetTicks();
					break;
				case 25:
					if(SetParameter(0x31, 0x50))
					{
						mvwprintw(win1, 1, 1, "Please press finger >>> ");
						DebugWin(win1, 5);
						data = malloc(TEMPLATES_SIZE);
						if(data == NULL)
						{
							mvwprintw(win1, 1, 1, "[ err ]malloc err ...");
							DebugWin(win1, 1);
							break;
						}
						startTime = GetTicks();
						ret = ScanTemplate(data);
						curTime = GetTicks();
						SetParameter(0x30, 0x50);
					}
					if(data != NULL)
					{
						free(data);
						data = NULL;
					}
					break;
				case 26:
					startTime = GetTicks();
					ret = EnableDevice();
					curTime = GetTicks();
					break;
				case 27:
					startTime = GetTicks();
					ret = DisableDevice();
					curTime = GetTicks();
					break;
				case 28:
					startTime = GetTicks();
					ret = Reset();
					curTime = GetTicks();
					break;
				case 29:
					mvwprintw(win, WIN_LINE - 7, 2, "Please input filename:");
					wclrtoeol(win);
					memset(filename, 0, sizeof(filename));
					mvwscanw(win, WIN_LINE - 7, 24, "%s", filename);
					fflush(stdin);
					data = malloc(FIRMWARE_SIZE);
					if (data == NULL) {
						break;
					}
					if((fsize = Read_FILE(data, filename)))
					{
						fprintf(logFile, "Is upgrading...\r\n");
						mvwprintw(win1, 1, 1, "[Debug]:Is upgrading...");
						DebugWin(win1, 1);
						startTime = GetTicks();
						ret = Upgrade(data, fsize);
						curTime = GetTicks();
					}
					if(data != NULL)
					{
						free(data);
						data = NULL;
					}
					break;
				case 30:
					mvwprintw(win, WIN_LINE - 7, 2, "Please input TemplatesFile name:");
					wclrtoeol(win);
					memset(filename, 0, sizeof(filename));
					mvwscanw(win, WIN_LINE - 7, 34, "%s", filename);
					fflush(stdin);
					data = malloc(FIRMWARE_SIZE * 7);
					if (data == NULL) {
						break;
					}
					if((fsize = Read_FILE(data, filename)))
					{
						fprintf(logFile, "Loading is template data ...\r\n");
						mvwprintw(win1, 1, 1, "[Debug]:Loading is template data ...");
						DebugWin(win1, 1);
						startTime = GetTicks();
						ret =  UploadTemplateFile(data, fsize);
						curTime = GetTicks();
					}
					if(data != NULL)
					{
						free(data);
						data = NULL;
					}
					break;
				case 31:
					mvwprintw(win, WIN_LINE - 7, 2, "Please input UserFile name:");
					wclrtoeol(win);
					memset(filename, 0, sizeof(filename));
					mvwscanw(win, WIN_LINE - 7, 29, "%s", filename);
					fflush(stdin);
					data = malloc(FIRMWARE_SIZE);
					if (data == NULL) {
						break;
					}
					if((fsize = Read_FILE(data, filename)))
					{
						fprintf(logFile, "Loading is user data ...\r\n");
						mvwprintw(win1, 1, 1, "[Debug]:Loading is user data ...");
						DebugWin(win1, 1);
						startTime = GetTicks();
						ret = UploadUserFile(data, fsize);
						curTime = GetTicks();
					}
					if(data != NULL)
					{
						free(data);
						data = NULL;
					}
					break;
				case 32:
					fprintf(logFile, "Is downloading...\r\n");
					mvwprintw(win1, 1, 1, "[Debug]:Is downloading...");
					DebugWin(win1, 1);
					startTime = GetTicks();
					ret = DownloadUserFile();
					curTime = GetTicks();
					break;
				case 33:
					fprintf(logFile, "Is downloading...\r\n");
					mvwprintw(win1, 1, 1, "[Debug]:Is downloading...");
					DebugWin(win1, 1);
					startTime = GetTicks();
					ret = DownloadTemplatesFile();
					curTime = GetTicks();
					break;
				case 66:
					if((ret = Disconnect()))
					{
						exit_flag = 1;
						reset_flag = 1;
					}
					break;
				case 77:
					ret = version();
					break;
				case 88:
					ret = ViewData();
					break;
				case 99:
					startTime = GetTicks();
					if(AutoDubug())
					{
						curTime = GetTicks();
						ret = 1;
						fprintf(logFile, "All Option...OK!\r\n");
						mvwprintw(win1, 1, 1, "All Option...OK!");
						DebugWin(win1, 2);
					}
					else
					{
						ret = 0;
						fprintf(logFile, "Err:Debug interrupt!\r\n");
						mvwprintw(win1, 1, 1, "Err:Debug interrupt!");
						DebugWin(win1, 2);
					}
					break;
				case 0:
					ret = Disconnect();
					ret = 1;
					exit_flag = 1;
					reset_flag = 0;
					break;
				default:
					mvwprintw(win1, 1, 1, "Select err...");
					continue;
			}
			if(ret)
			{
				fprintf(logFile, "[ ok ] [%d]ok----> run time = %.3fs\n", num, (curTime - startTime)/1000.0);
				mvwprintw(win1, 1, 1, "Operation is successful!");
			}
			else
			{
				DisplayFail(GetLastErr());
				fprintf(logFile, "[ err ] [%d]err----> run time = %.3fs\n", num, (curTime - startTime)/1000.0);
				mvwprintw(win1, 1, 1, "Operation failure...");
			}
			DebugWin(win1, 2);
			fclose(logFile);
			logFile = NULL;
			if(exit_flag)
			{
				break;
			}
			if(!AUTODEBUG)
			{
				mvwprintw(win1, 1, 1, "Press any key to continue!");
				wclrtoeol(win);
				DebugWin(win1, 0);
				mvgetch(WIN_LINE - 6, 8);
				touchwin(win);
			}
		}

		/******************** Close *********************/
		CloseWin();
		if(reset_flag == 0)
		{
			break;
		}
	}
	return TRUE;
}

/********************* User file *************************/
INT WU_FILE(VOID)
{
	FILE *fp = NULL;
	CHAR filename[DIRSIZE];
	CHAR curPath[DIRSIZE];
	tUser user;

	memset(curPath, 0, sizeof(curPath));
	//open path
	if(!Write_file('u', curPath))
	{
		return FAILURE;
	}
	//Output to file
	while(1)
	{
		if(ReadAllUser(((int *)(&user.userID)), user.Name, user.Password, &user.SecLevel,\
				&user.PIN2, &user.Privilege, &user.Fpnum, user.Card))
		{
			memset(filename, 0, sizeof(filename));
			sprintf(filename, "%d", user.userID);
			if(NULL == (fp = fopen(filename, "wb")))
			{
				mvwprintw(win1, 1, 1, "new file err...%s:%d:%s", __FILE__, __LINE__,  __func__);
				DebugWin(win1, 2);
				return FAILURE;
			}
			fwrite(&user, sizeof(tUser), 1, fp);
			fclose(fp);
			fp = NULL;
		}
		else
		{
			break;
		}
	}
	mvwprintw(win1, 1, 1, "User File write OK!");
	DebugWin(win1, 2);
	fprintf(logFile, "[17]User File write.....OK!\r\n");
	if(chdir(curPath))
	{
		mvwprintw(win1, 1, 1, "chdir err...%s:%d:%s", __FILE__, __LINE__,  __func__);
		DebugWin(win1, 2);
		return FAILURE;
	}
	return SUCCESS;
}

INT ReadTempFromM(INT model)
{
	INT userID = 0;
	INT index = 0;
	INT flag = 0;
	FILE *fp = NULL;
	CHAR filename[DIRSIZE];
	CHAR curPath[DIRSIZE];
	U8 data[TEMPLATES_SIZE];

	memset(filename, 0, sizeof(filename));
	memset(curPath, 0, sizeof(curPath));
	//open path
	if(!Write_file('t', curPath))
	{
		return FAILURE;
	}
	//Output to file
	switch(model)
	{
		case 0:
			input_info(&userID);
			DebugWin(win1, 0);
			mvwprintw(win, WIN_LINE - 7, 2, "Please input index(0~9):");
			wclrtoeol(win);
			mvwscanw(win, WIN_LINE - 7, 26, "%d", &index);
			fflush(stdin);
			mvwprintw(win, WIN_LINE - 7, 2, "Please input flag[0 or 1]:");
			wclrtoeol(win);
			mvwscanw(win, WIN_LINE - 7, 28, "%d", &flag);
			fflush(stdin);
			memset(data, 0, sizeof(data));
			if(ReadTemplates(userID, index, flag, data))
			{
				sprintf(filename, "%d_%d", userID, index);
				if(NULL == (fp = fopen(filename, "wb")))
				{
					mvwprintw(win1, 1, 1, "new file err...%s:%d:%s", __FILE__, __LINE__,  __func__);
					DebugWin(win1, 2);
					return FAILURE;
				}
				fwrite(data, sizeof(data), 1, fp);
				fclose(fp);
			}
			break;
		case 1:
			//all templates
			sprintf(filename, "AllTemplates");
			if(NULL == (fp = fopen(filename, "wb"))) //open file
			{
				mvwprintw(win1, 1, 1, "new file err...%s:%d:%s", __FILE__, __LINE__,  __func__);
				DebugWin(win1, 2);
				return FAILURE;
			}
			while(1)
			{
				memset(data, 0, sizeof(data));
				if(ReadAllTemplates(data))
				{
					fwrite(data, sizeof(data), 1, fp);
				}
				else
				{
					break;
				}
			}
			fclose(fp);
			break;
		default :
			mvwprintw(win1, 1, 1, "model err");
			DebugWin(win1, 2);
			break;
	}
	mvwprintw(win1, 1, 1, "Templates File write OK!");
	DebugWin(win1, 2);

	if(chdir(curPath))
	{
		mvwprintw(win1, 1, 1, "chdir err...%s:%d:%s", __FILE__, __LINE__,  __func__);
		DebugWin(win1, 2);
		return FAILURE;
	}
	return SUCCESS;
}

INT WL_FILE(VOID)
{
	FILE *fp = NULL;
	CHAR filename[DIRSIZE];
	CHAR curPath[DIRSIZE];
	tLog user;

	memset(curPath, 0, sizeof(curPath));
	//open path
	if(!Write_file('l', curPath))
	{
		return FAILURE;
	}

	//Output to file
	while(1)
	{
		if(ReadAllLogs(((INT *)(&user.userID)), &user.Event, &user.verified, &user.Date,
				&user.Time, user.Reserved))
		{
			memset(filename, 0, sizeof(filename));
			sprintf(filename, "%d", user.userID);
			if(NULL == (fp = fopen(filename, "wb")))
			{
				mvwprintw(win1, 1, 1, "new file err...%s:%d:%s", __FILE__, __LINE__,  __func__);
				DebugWin(win1, 2);
				return FAILURE;
			}
			fwrite(&user, sizeof(tLog), 1, fp);
			fclose(fp);
		}
		else
		{
			break;
		}
	}

	mvwprintw(win1, 1, 1, "Logs File write OK!");
	DebugWin(win1, 2);

	if(chdir(curPath))
	{
		mvwprintw(win1, 1, 1, "chdir err...%s:%d:%s", __FILE__, __LINE__,  __func__);
		DebugWin(win1, 2);
		return FAILURE;
	}
	return SUCCESS;
}

U32 Read_FILE(U8 *data, CHAR *path)
{
	U32 fsize = 0;
	FILE *fp = NULL;
	U8 *buff = NULL;

	if(NULL == (fp = fopen(path, "rb+")))
	{
		mvwprintw(win1, 1, 1, "FILE: NOT_FIND");
		DebugWin(win1, 2);
		return FAILURE;
	}
	if(-1 == fseek(fp, 0, SEEK_END))
	{
		mvwprintw(win1, 1, 1, "fseek err...%s:%d:%s", __FILE__, __LINE__,  __func__);
		DebugWin(win1, 2);
		return FAILURE;
	}
	fsize = ftell(fp);
	if(-1 == fseek(fp, 0, SEEK_SET))
	{
		mvwprintw(win1, 1, 1, "fseek err...%s:%d:%s", __FILE__, __LINE__,  __func__);
		DebugWin(win1, 2);
		return FAILURE;
	}
	buff = malloc(fsize);
	if(buff == NULL)
	{
		mvwprintw(win1, 1, 1, "[ err ]malloc err ...");
		DebugWin(win1, 1);
		return FAILURE;
	}
	//start print
	if(fread(buff, fsize, 1, fp))
	{
		if(DEBUG)
		{
			mvwprintw(win1, 1, 1, "Read  File OK!");
			DebugWin(win1, 2);
		}
	}
	memcpy(data, buff, fsize);

	fclose(fp);
	fp = NULL;
	if(buff != NULL)
	{
		free(buff);
		buff = NULL;
	}
	return fsize;
}

INT ReadTempFromPc(U8 *data, CHAR *filename)
{
	CHAR *path = NULL;

	path = malloc(DIRSIZE);
	if(path == NULL)
	{
		mvwprintw(win1, 1, 1, "[ err ]malloc err ...");
		DebugWin(win1, 1);
		return FAILURE;
	}
	sprintf(path, "./Templates/%s", filename);
	if(!Read_FILE(data, path))
	{
		return FAILURE;
	}
	if(path != NULL)
	{
		free(path);
		path = NULL;
	}
	return SUCCESS;
}

INT ViewData(VOID)
{
	INT y = 1;
	INT x = 1;
	mvwprintw(win2, y++, x, "%-10s%-13s%s", "DATA", "PATH", "EXPLAIN");
	mvwprintw(win2, y++, x, "%-10s%-13s", "user","./User/");
	mvwprintw(win2, y++, x, "%-10s%-13s","template", "./Templates/");
	mvwprintw(win2, y++, x, "%-10s%-13s","logs", "./Logs/");
	mvwprintw(win2, y++, x, "%-10s%-13s","debug.log", "./");
	touchwin(win2);
	wrefresh(win2);
	werase(win2);
	return SUCCESS;
}


INT AutoDubug(VOID)
{
	INT value = -1;
	INT ret = -1;
	INT index = 0;
	INT Year = 0;
	INT Month = 0;
	INT Day = 0;
	INT Hour = 0;
	INT Minute = 0;
	INT Second = 0;
	S32 width = 0;
	S32 height = 0;

	INT userID;
	CHAR name[8];
	CHAR password[5];
	CHAR filename[DIRSIZE];
	U8 privilege;
	U8 figerprintNum;
	U8 Card[5];
	U16 secLevel;
	U32 PIN2;
	U8 *data = NULL;
	memset(Card, 0, sizeof(Card));

	DebugFilInit();
	//start dubeg
	mvwprintw(win1, 1, 1, "Please press figerprint!(3 times) >>>");
	DebugWin(win1, 0);
	ret = EnrollUserByScan(1001);
	if(ret <= 0)
	{
		fprintf(logFile, "[01]--->EnrollUserBySan ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[01]--->EnrollUserByScan.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[01]--->EnrollUserByScan.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[02]--->EnrollTemplateByImage");
	DebugWin(win1, 1);
	mvwprintw(win, WIN_LINE - 7, 2, "Please input filename:");
	wclrtoeol(win);
	memset(filename, 0, sizeof(filename));
	mvwscanw(win, WIN_LINE - 7, 24, "%s", filename);
	fflush(stdin);
	mvwprintw(win1, 1, 1, "Please wait a moment, data is receving ...");
	DebugWin(win1, 1);
	data = malloc(IMAGE_SIZE);
	if(data == NULL)
	{
		mvwprintw(win1, 1, 1, "[ err ]malloc err ...");
		DebugWin(win1, 1);
		return FAILURE;
	}
	ret = readFingerImage(data, &width, &height, filename);
	if(ret <= 0)
	{
		fprintf(logFile, "[02-1]--->readFingerImage.....OK!\r\n");
		return FAILURE;
	}
	mvwprintw(win1, 1, 1, "Please wait a moment, data is sending ...");
	DebugWin(win1, 0);
	ret = EnrollTemplateByImage(1002, data, width * height);
	if(data != NULL)
	{
		free(data);
		data = NULL;
	}
	if(ret <= 0)
	{
		fprintf(logFile, "[02-2]--->EnrollTemplateByImage ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[02]--->EnrollTemplateByImage.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[02]--->EnrollTemplateByImage.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[03]--->GetFingerImage");
	mvwprintw(win1, 3, 1, "Please press figerprint! >>>");
	DebugWin(win1, 10);
	if(Dev_num == DEV_USB)
	{
		Clear();
	}
	mvwprintw(win1, 1, 1, "Please wait a moment, data is receving ...");
	DebugWin(win1, 1);
	data = malloc(IMAGE_SIZE);
	if(data == NULL)
	{
		mvwprintw(win1, 1, 1, "[ err ]malloc err ...");
		DebugWin(win1, 1);
		return FAILURE;
	}
	if(!(ret = GetFingerImage((int *)&width, (int *)&height, data)))
	{
		return FAILURE;
	}
	save_bmp(data, width, height);
	if(data != NULL)
	{
		free(data);
		data = NULL;
	}
	mvwprintw(win1, 1, 1, "[03]--->GetFingerImage.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[04]--->IdentifyByImage");
	DebugWin(win1, 1);
	mvwprintw(win, WIN_LINE - 7, 2, "Please input filename:");
	wclrtoeol(win);
	memset(filename, 0, sizeof(filename));
	mvwscanw(win, WIN_LINE - 7, 24, "%s", filename);
	fflush(stdin);
	mvwprintw(win1, 1, 1, "Please wait a moment, data is receving ...");
	DebugWin(win1, 1);
	data = malloc(IMAGE_SIZE);
	if(data == NULL)
	{
		mvwprintw(win1, 1, 1, "[ err ]malloc err ...");
		DebugWin(win1, 1);
		return FAILURE;
	}
	ret = readFingerImage(data, &width, &height, filename);
	if(ret <= 0)
	{
		fprintf(logFile, "[04-1]--->readFingerImage.....OK!\r\n");
		return FAILURE;
	}
	mvwprintw(win1, 1, 1, "Please wait a moment, data is sending ...");
	DebugWin(win1, 0);
	ret = IdentifyByImage(width * height, &userID, &index, data);
	if(ret <= 0)
	{
		fprintf(logFile, "[04-2]--->IdentifyByImage ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[04]--->IdentifyByImage.....OK!\r\n");
	if(data != NULL)
	{
		free(data);
		data = NULL;
	}
	mvwprintw(win1, 1, 1, "[04]--->IdentifyByImage.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[05]--->Verify");
	DebugWin(win1, 1);
	mvwprintw(win1, 1, 1, "Please press finger >>> ");
	DebugWin(win1, 0);
	ret = Verify(1001);
	if(ret <= 0)
	{
		fprintf(logFile, "[05]--->Verify ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[05]--->Verify.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[05]--->Verify.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[19]--->ModifyUser");
	DebugWin(win1, 1);
	ret = ModifyUser(1003, "atao", "1234", 1, 1001, 0, 0, Card);
	if(ret <= 0)
	{
		fprintf(logFile, "[19]--->ModifyUser ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[19]--->ModifyUser.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[19]--->ModifyUser.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[09]--->SetTime");
	DebugWin(win1, 1);
	ret = SetTime(2015, 9, 29, 17, 59, 57);
	if(ret <= 0)
	{
		fprintf(logFile, "[09]--->SetTime ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[09]--->SetTime.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[09]--->SetTime.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[10]--->GetTime");
	DebugWin(win1, 1);
	ret = GetTime(&Year, &Month, &Day,  &Hour, &Minute, &Second);
	if(ret <= 0)
	{
		fprintf(logFile, "[10]--->GetTime ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[10]--->GetTime.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[10]--->GetTime.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[11]--->GetStatus");
	DebugWin(win1, 1);
	ret = GetStatus();
	if(ret <= 0)
	{
		fprintf(logFile, "[11]--->GetStatus ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[11]--->GetStatus.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[11]--->GetStatus.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[12]--->GetParameter");
	DebugWin(win1, 1);
	ret = GetParameter(0x71, &value);
	if(ret <= 0)
	{
		fprintf(logFile, "[12]--->GetParameter ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[12]--->GetParameter.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[12]--->GetParameter.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[13]--->SetParameter");
	DebugWin(win1, 1);
	ret = SetParameter(0x30, 0x82);
	if(ret <= 0)
	{
		fprintf(logFile, "[13]--->SetParameter ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[13]--->SetParameter.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[13]--->SetParameter.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[14]--->SaveParameter");
	DebugWin(win1, 1);
	ret = SaveParameter();
	if(ret <= 0)
	{
		fprintf(logFile, "[14]--->SaveParameter ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[14]--->SaveParameter.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[14]--->SaveParameter.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[18]--->GetUser");
	DebugWin(win1, 1);
	ret = GetUser(1001, name, password, &secLevel, &PIN2, &privilege, &figerprintNum, Card);
	if(ret <= 0)
	{
		fprintf(logFile, "[18]--->GetUser ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[18]--->GetUser.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[18]--->GetUser.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[17]--->ReadAllUsers");
	DebugWin(win1, 1);
	ret = WU_FILE();//wirte user file
	if(ret <= 0)
	{
		fprintf(logFile, "[17]--->ReadAllUsers ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[17]--->ReadAllUsers.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[17]--->ReadAllUsers.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[23]--->ReadTemplates");
	DebugWin(win1, 1);
	ret = ReadTempFromM(0);//write templates file
	if(ret <= 0)
	{
		fprintf(logFile, "[23]--->ReadTemplates ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[23]--->ReadTemplates.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[23]--->ReadTemplates.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[20]--->SetTemplates");
	DebugWin(win1, 5);
	data = malloc(TEMPLATES_SIZE);
	if(data == NULL)
	{
		mvwprintw(win1, 1, 1, "[ err ]malloc err ...");
		DebugWin(win1, 1);
		return FAILURE;
	}
	mvwprintw(win, WIN_LINE - 7, 2, "Please input filename:");
	wclrtoeol(win);
	memset(filename, 0, sizeof(filename));
	mvwscanw(win, WIN_LINE - 7, 24, "%s", filename);
	fflush(stdin);
	if(ReadTempFromPc(data, filename))
	{
		ret =  SetTemplates(1003, 0, data, TEMPLATES_SIZE);
		if(ret <= 0)
		{
			fprintf(logFile, "[20]--->SetTemplates ...err\r\n");
		}
		else
		{
			fprintf(logFile, "[20]--->SetTemplates.....OK!\r\n");
		}
	}
	if(data != NULL)
	{
		free(data);
		data = NULL;
	}
	mvwprintw(win1, 1, 1, "[20]--->SetTemplates.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[21]--->DeleteTemplates");
	DebugWin(win1, 1);
	ret = DeleteTemplates(1001, 0, 0);
	if(ret <= 0)
	{
		fprintf(logFile, "[21]--->DeleteTemplates ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[21]--->DeleteTemplates.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[21]--->DeleteTemplates.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[24]--->ReadAllTemplates");
	DebugWin(win1, 1);
	ret = ReadTempFromM(1);//write templates file
	if(ret <= 0)
	{
		fprintf(logFile, "[24]--->ReadAllTemplates ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[24]--->ReadAllTemplates.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[24]--->ReadAllTemplates.....OK!");
	DebugWin(win1, 1);

	ret = DeleteUser(1001);
	if(ret <= 0)
	{
		fprintf(logFile, "[16]--->DeleteUser ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[16]--->DeleteUser.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[16]--->DeleteUser.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[15]--->DeleteAllUsers");
	DebugWin(win1, 1);
	ret = DeleteAllUsers();
	if(ret <= 0)
	{
		fprintf(logFile, "[15]--->DeleteAllUsers ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[15]--->DeleteAllUsers.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[15]--->DeleteAllUsers.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[22]--->DeleteAllTemplates");
	DebugWin(win1, 1);
	ret = DeleteAllTemplates();
	if(ret <= 0)
	{
		fprintf(logFile, "[22]--->DeleteAllTemplates ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[22]--->DeleteAllTemplates.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[22]--->DeleteAllTemplates.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[06]--->DeleteAllLogs");
	DebugWin(win1, 1);
	ret = DeleteAllLogs();
	if(ret <= 0)
	{
		fprintf(logFile, "[06]--->DeleteAllLogs ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[06]--->DeleteAllLogs.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[06]--->DeleteAllLogs.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[07]--->ClearDB");
	DebugWin(win1, 1);
	ret = ClearDB();
	if(ret <= 0)
	{
		fprintf(logFile, "[07]--->ClearDB ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[07]--->ClearDB.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[07]--->ClearDB.....OK!");
	DebugWin(win1, 1);

	return SUCCESS;
}

/************************* Fail info ************************/
INT DisplayFail(INT Flag)
{
	mvwprintw(win1, 1, 1, "Fail Info :");
	switch(Flag)
	{
		case ERR_FAIL:
			mvwprintw(win1, 1, 12, "FAIL");
			break;
		case ERR_TIME_OUT:
			mvwprintw(win1, 1, 12, "TIME_OUT");
			break;
		case ERR_MEM_FULL:
			mvwprintw(win1, 1, 12, "MEM_FULL");
			break;
		case ERR_PARAM_ERROR:
			mvwprintw(win1, 1, 12, "PARAM_ERROR");
			break;
		case ERR_NOT_FIND:
			mvwprintw(win1, 1, 12, "NOT_FIND");
			break;
		case ERR_FP_LIMIT:
			mvwprintw(win1, 1, 12, "FP_LIMIT");
			break;
		case ERR_INVALID_ID:
			mvwprintw(win1, 1, 12, "INVALID_ID");
			break;
		case ERR_CANCELED:
			mvwprintw(win1, 1, 12, "CANCELED");
			break;
		case ERR_DATA_ERROR:
			mvwprintw(win1, 1, 12, "DATA_ERROR");
			break;
		case ERR_EXIST_FP:
			mvwprintw(win1, 1, 12, "EXIST_FP");
			break;
		default:
			break;
	}
	DebugWin(win1, 1);
	return SUCCESS;
}

INT Write_file(CHAR dir_flag, CHAR *curPath)
{
	CHAR *ePath = NULL;

	if(NULL == (getcwd(curPath, DIRSIZE)))
	{
		mvwprintw(win1, 1, 1, "getcwd err...%s:%d:%s", __FILE__, __LINE__,  __func__);
		DebugWin(win1, 2);
		return FAILURE;
	}
	mvwprintw(win1, 1, 1, "curPath:%s", curPath);
	DebugWin(win1, 2);

	switch(dir_flag)
	{
		case 'l':
			ePath = LOGS_DIR;
			break;
		case 'u':
			ePath = USER_DIR;
			break;
		case 't':
			ePath = TEMPLATE_DIR;
			break;
		default :
			break;
	}
	if(-1 == access(ePath, 0))
	{
	    if(-1 == mkdir(ePath, 0777))
	    {
			mvwprintw(win1, 1, 1, "mkdir err...%s:%d:%s", __FILE__, __LINE__,  __func__);
			DebugWin(win1, 2);
			return FAILURE;
	    }
	}
	if(chdir(ePath))
	{
		mvwprintw(win1, 1, 1, "chdir err...%s:%d:%s", __FILE__, __LINE__,  __func__);
		DebugWin(win1, 2);
		return FAILURE;
	}
	if(Dev_num == DEV_USB)
	{
		Clear();
	}
	return SUCCESS;
}

VOID *threadAutoDebug(VOID *arg)
{
	INT value = -1;
	INT ret = -1;
	INT Year = 0;
	INT Month = 0;
	INT Day = 0;
	INT Hour = 0;
	INT Minute = 0;
	INT Second = 0;
	CHAR name[8];
	CHAR password[5];
	U8 privilege;
	U8 figerprintNum;
	U8 Card[5];
	U16 secLevel;
	U32 PIN2;
	U8 *data = NULL;
	memset(Card, 0, sizeof(Card));

	DebugFilInit();
	//start dubeg
	mvwprintw(win1, 2, 1, "Running >>>[09]--->SetTime");
	DebugWin(win1, 0);
	ret = SetTime(2015, 12, 14, 12, 01, 0);
	if(ret <= 0)
	{
		fprintf(logFile, "[09]--->SetTime ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[09]--->SetTime.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[09]--->SetTime.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[10]--->GetTime");
	DebugWin(win1, 0);
	ret = GetTime(&Year, &Month, &Day,  &Hour, &Minute, &Second);
	if(ret <= 0)
	{
		fprintf(logFile, "[10]--->GetTime ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[10]--->GetTime.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[10]--->GetTime.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[11]--->GetStatus");
	DebugWin(win1, 0);
	ret = GetStatus();
	if(ret <= 0)
	{
		fprintf(logFile, "[11]--->GetStatus ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[11]--->GetStatus.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[11]--->GetStatus.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[12]--->GetParameter");
	DebugWin(win1, 0);
	ret = GetParameter(0x71, &value);
	if(ret <= 0)
	{
		fprintf(logFile, "[12]--->GetParameter ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[12]--->GetParameter.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[12]--->GetParameter.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[13]--->SetParameter");
	DebugWin(win1, 0);
	ret = SetParameter(0x30, 0x82);
	if(ret <= 0)
	{
		fprintf(logFile, "[13]--->SetParameter ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[13]--->SetParameter.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[13]--->SetParameter.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[14]--->SaveParameter");
	DebugWin(win1, 0);
	ret = SaveParameter();
	if(ret <= 0)
	{
		fprintf(logFile, "[14]--->SaveParameter ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[14]--->SaveParameter.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[14]--->SaveParameter.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[19]--->ModifyUser");
	DebugWin(win1, 0);
	ret = ModifyUser(1003, "atao", password, 0, 1003, 0, 0, Card);
	if(ret <= 0)
	{
		fprintf(logFile, "[19]--->ModifyUser ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[19]--->ModifyUser.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[19]--->ModifyUser.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[20]--->SetTemplates");
	DebugWin(win1, 0);
	data = malloc(TEMPLATES_SIZE);
	if(data == NULL)
	{
		mvwprintw(win1, 1, 1, "[ err ]malloc err ...");
		DebugWin(win1, 0);
		pthread_exit("[ err ]");
	}
	if(ReadTempFromPc(data, "1001_0"))
	{
		ret =  SetTemplates(1001, 0, data, TEMPLATES_SIZE);
		if(ret <= 0)
		{
			fprintf(logFile, "[20]--->SetTemplates ...err\r\n");
		}
		else
		{
			fprintf(logFile, "[20]--->SetTemplates.....OK!\r\n");
		}
	}
	if(data != NULL)
	{
		free(data);
		data = NULL;
	}
	mvwprintw(win1, 1, 1, "[20]--->SetTemplates.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[18]--->GetUser");
	DebugWin(win1, 0);
	ret = GetUser(1001, name, password, &secLevel, &PIN2, &privilege, &figerprintNum, Card);
	if(ret <= 0)
	{
		fprintf(logFile, "[18]--->GetUser ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[18]--->GetUser.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[18]--->GetUser.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[17]--->ReadAllUsers");
	DebugWin(win1, 0);
	ret = WU_FILE();//wirte user file
	if(ret <= 0)
	{
		fprintf(logFile, "[17]--->ReadAllUsers ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[17]--->ReadAllUsers.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[17]--->ReadAllUsers.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[24]--->ReadAllTemplates");
	DebugWin(win1, 0);
	ret = ReadTempFromM(1);//write templates file
	if(ret <= 0)
	{
		fprintf(logFile, "[24]--->ReadAllTemplates ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[24]--->ReadAllTemplates.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[24]--->ReadAllTemplates.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[16]--->DeleteUser");
	DebugWin(win1, 0);

	ret = DeleteUser(1001);
	if(ret <= 0)
	{
		fprintf(logFile, "[16]--->DeleteUser ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[16]--->DeleteUser.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[16]--->DeleteUser.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[15]--->DeleteAllUsers");
	DebugWin(win1, 0);
	ret = DeleteAllUsers();
	if(ret <= 0)
	{
		fprintf(logFile, "[15]--->DeleteAllUsers ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[15]--->DeleteAllUsers.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[15]--->DeleteAllUsers.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[22]--->DeleteAllTemplates");
	DebugWin(win1, 0);
	ret = DeleteAllTemplates();
	if(ret <= 0)
	{
		fprintf(logFile, "[22]--->DeleteAllTemplates ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[22]--->DeleteAllTemplates.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[22]--->DeleteAllTemplates.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[06]--->DeleteAllLogs");
	DebugWin(win1, 0);
	ret = DeleteAllLogs();
	if(ret <= 0)
	{
		fprintf(logFile, "[06]--->DeleteAllLogs ...err\r\n");
		pthread_exit("[ err ]");
	}
	fprintf(logFile, "[06]--->DeleteAllLogs.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[06]--->DeleteAllLogs.....OK!");
	mvwprintw(win1, 2, 1, "Running >>>[07]--->ClearDB");
	DebugWin(win1, 0);
	ret = ClearDB();
	if(ret <= 0)
	{
		fprintf(logFile, "[07]--->ClearDB ...err\r\n");
		return FAILURE;
	}
	fprintf(logFile, "[07]--->ClearDB.....OK!\r\n");
	mvwprintw(win1, 1, 1, "[07]--->ClearDB.....OK!");
	DebugWin(win1, 0);

	(*((INT *)arg))++;
	pthread_exit("[ ok ]");
}

INT readFingerImage(U8 *buffer, S32 *Width, S32 *Height, CHAR * FileName)
{

	int len = 0;
	int headSize = 0;
	FILE *fp = NULL;
	U8 *image = NULL;
	BITMAPINFOHEADER imageHead;

	// 1.open image
	if(NULL == (fp = fopen(FileName, "rb")))
	{
		return FAILURE;
	}

	headSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD);

	fseek(fp, 0, SEEK_END);
	len = ftell(fp);
	fseek(fp, 0, SEEK_SET);

	// 2.read image file
	image = malloc(IMAGE_SIZE);
	if(image == NULL)
	{
		return FAILURE;
	}
	memset(image, 0, IMAGE_SIZE);
	if(!fread(image, len, 1, fp))
	{
		return FAILURE;
	}

	// 3.return image data
	memcpy(buffer, image + headSize, len - headSize);

	//read image width and height
	memcpy(&imageHead, image + sizeof(BITMAPFILEHEADER), sizeof(BITMAPFILEHEADER));
	*Width = imageHead.biWidth;
	*Height = imageHead.biHeight;
	mvwprintw(win1, 1, 1, "[ ok ]read image ok!");
	mvwprintw(win1, 2, 1, "width = %ld height = %ld", *Width, *Height);
	DebugWin(win1, 3);
	// 4.free
	fclose(fp);
	free(image);
	image = NULL;

	return SUCCESS;
}

INT ReadParameter(VOID)
{
	INT  i = 0;
	INT value[14];
	CHAR ver[6];

	memset(value, 0, sizeof(value));
	for(i = 0; i < 14; ++i)
	{
		if(!GetParameter(parameter_value[i], &value[i]))
		{
			return FAILURE;
		}
	}
	ver[4] = value[3]&0xffff;
	value[3]>>=8;
	ver[3] = value[3]&0xffff;
	value[3]>>=8;
	ver[1] = value[3]&0xffff;
	value[3]>>=8;
	ver[0] = value[3]&0xffff;
	ver[2] = '.';
	ver[5] = '\0';
	i = 1;
	mvwprintw(win2, i++, 1, "[ 01 ]saveLog = %s", (value[0] == 0x30) ? "off" : "on");
	mvwprintw(win2, i++, 1, "[ 02 ]autoACK = %s", (value[1] == 0x30) ? "off" : "on");
	mvwprintw(win2, i++, 1, "[ 03 ]timeout = 0x%x", value[2]);
	mvwprintw(win2, i++, 1, "[ 04 ]fwVer = %s", ver);
	mvwprintw(win2, i++, 1, "[ 05 ]baudrate = %s", (value[4] == 0x35) ? "115200bps" : "unknow");
	mvwprintw(win2, i++, 1, "[ 06 ]enrollFp = %d", value[5]);
	mvwprintw(win2, i++, 1, "[ 07 ]fpCount = %d", value[6]);
	mvwprintw(win2, i++, 1, "[ 08 ]userCount = %d", value[7]);
	mvwprintw(win2, i++, 1, "[ 09 ]logNum = %d", value[8]);
	mvwprintw(win2, i++, 1, "[ 10 ]logCount = %d", value[9]);
	mvwprintw(win2, i++, 1, "[ 11 ]buildTime = 20%x", value[10]);
	mvwprintw(win2, i++, 1, "[ 12 ]moduleID = %d", value[11]);
	mvwprintw(win2, i++, 1, "[ 13 ]FpFormat  = %s", (value[12] == 0x30) ? "ZK" : (value[12] == 0x32) ? "Ansi378" : "ISO19794-2");
	mvwprintw(win2, i++, 1, "[ 14 ]moduleIdentify = %s", (value[13] == 0x30) ? "authentication mode" : (value[13] == 0x31) ? "reader(image)" : "reader(template)");

	touchwin(win2);
	wrefresh(win2);
	werase(win2);

	return SUCCESS;
}

VOID GetFreeScan(INT ScanUser)
{
	if(ScanUser > 0)
	{
		mvwprintw(win1, 1, 1, "[ Debug ]Thread joined,it returned:[ ok ] UserID = %d", ScanUser);
	}
	else
	{
		mvwprintw(win1, 1, 1, "[ Debug ]Thread joined,it returned:[ err ] UserID = unknow");
	}
	DebugWin(win1, 2);
}


