
/*============================================================================
 Name        : libtype.h
 Author      : atao
 Date  	     : 2015.9
 Copyright   : ZKTeco.
 Description : Linux C
 ============================================================================*/

#ifndef 	_LIBTYPE_H_
#define 	_LIBTYPE_H_

#ifndef GCC_PACKED
#define GCC_PACKED		__attribute__((packed))
#endif

typedef     unsigned char       U8;         // unsigned 8 bit integer
typedef     signed char         S8;         // signed 8 bit integer

typedef     unsigned short      U16;        // unsigned 16 bit integer
typedef     signed short        S16;        // signed 16 bit integer

typedef     unsigned long       U32;        // unsigned 32 bit integer
typedef     signed long         S32;        // signed 32 bit integer

typedef     char                CHAR;       // char
typedef     short               SHORT;      // short
typedef     int                 INT;        // int

typedef     float               FLOAT;      // float
typedef     double              DOUBLE;     // double
typedef     void                VOID;       // void
typedef     void *              pVOID;      // void *

#define 	USERID_MAX			65535

#define		FAILURE				0
#define		SUCCESS				1


#define 	TEMPLATES_SIZE		(1024*2)

#define 	ERR_FAIL 				0x63
#define 	ERR_TIME_OUT			0x6C
#define 	ERR_MEM_FULL			0x6D
#define 	ERR_PARAM_ERROR			0x68
#define 	ERR_NOT_FIND 			0x69
#define 	ERR_FP_LIMIT			0x72
#define 	ERR_INVALID_ID			0x76
#define 	ERR_CANCELED			0x81
#define 	ERR_DATA_ERROR			0x82
#define 	ERR_EXIST_FP			0x86

#define 	SID_GPIO_LEVEL		0x31	// GPIO level
#define 	SID_SAVE_LOG		0x36	// save log
#define 	SID_MODULE_IDENTIFY 0x50
#define 	SID_TIMEOUT			0x62	//time out
#define 	SID_MODULE_ID		0x6D	//module id
#define 	SID_AUTO_ACK		0x82	// auto response when free scan

//system parameter
#define SID_FP_FORMAT		0x51
#define SID_MODULE_IDENTIFY 0x50
#define SID_TIMEOUT			0x62	//time out
#define SID_MODULE_ID		0x6D	//module id
#define SID_FW_VER			0x6E	//firmware version
#define SID_BAUDRATE		0x71	//baudrate 57600
#define SID_ENROLL_FP		0x73	//Current number of Enrolled fp
#define SID_FP_COUNT		0x74	// the available number of fp that can  be enrolled
#define SID_USER_COUNT		0x79	//Max user count
#define SID_LOG_COUNT		0x7B	//maximum Log Count
#define SID_LOG_NUM			0x7C	//Log number
#define SID_AUTO_ACK		0x82	// auto response when free scan
#define SID_BUILD_NUM		0x89	//builed number
#define SID_GPIO_LEVEL		0x31
#define	SID_MODULE_ID		0x6D
#endif


