
/*============================================================================
 Name        : main.h
 Author      : atao
 Date  	     : 2015.10
 Copyright   : ZKTeco.
 Description : Linux C
 ============================================================================*/
#ifndef _MAIN_H_
#define _MAIN_H_

#include <curses.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

#define DEMOVERSION		"V2.0.3"
#define	IMAGE_SIZE		(400 * 400)
#define AUTODEBUG		0

int readFingerImage(unsigned char *buffer, signed long *Width, signed long *Height, char * FileName);
/************************** User file ***************************/
int WU_FILE(void);
int ReadTempFromM(int model);
int ReadTempFromPc(unsigned char *data, char *filename);
int WL_FILE(void);
unsigned long Read_FILE(unsigned char *data, char *path);
int Write_file(char dir_flag, char *curPath);

int ViewData(void);
int version(void);
/**************************** debug *****************************/
int DebugFilInit(void);
void PrintInfo(void);
int input_info(int *userID);
int new_user(int *userID, char *name, char *password, unsigned char *Card);
void *threadAutoDebug(void *arg);
void GetFreeScan(int ScanUser);
/******************************** window ************************************/
int CursesInit(void);
void WinBox(void);
void CloseWin(void);
void DebugWin(WINDOW *win1, int num);
int DisplayFail(int Flag);

/********************* curses ***********************/
extern WINDOW *win, *win1, *win2;
#define WIN_COL		85
#define WIN_LINE	28

/****************************** save and read image ********************************/
void save_bmp(unsigned char *buffer, signed long Width, signed long Height);
int WriteBitmap(unsigned char *buffer, signed long Width, signed long Height, char * FileName);
int read_image(char *filename, unsigned char *data);

/*****************************************************/
int ReadParameter(void);

#pragma pack(1)

typedef struct tagBITMAPFILEHEADER {
	U16 bfType;
	U32 bfSize;
	U16 bfReserved1;
	U16 bfReserved2;
	U32 bfOffBits;
} BITMAPFILEHEADER, *LPBITMAPFILEHEADER, *PBITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER {
	U32 biSize;
	S32 biWidth;
	S32 biHeight;
	U16 biPlanes;
	U16 biBitCount;
	U32 biCompression;
	U32 biSizeImage;
	S32 biXPelsPerMeter;
	S32 biYPelsPerMeter;
	U32 biClrUsed;
	U32 biClrImportant;
} BITMAPINFOHEADER, *LPBITMAPINFOHEADER, *PBITMAPINFOHEADER;

typedef struct tagRGBQUAD {
	U8 rgbBlue;
	U8 rgbGreen;
	U8 rgbRed;
	U8 rgbReserved;
} RGBQUAD;

typedef struct tagBITMAPINFO {
	BITMAPINFOHEADER bmiHeader;
	RGBQUAD bmiColors[1];
} BITMAPINFO, *LPBITMAPINFO, *PBITMAPINFO;

#pragma pack()

#endif /* _MAIN_H_ */
